/*
 * Task_Sheduler.c
 *
 *  Created on: Jan 31, 2017
 *      Author: alberts
 */

#include "inc/hw_types.h"
//#include "inc/hw_memmap.h"
//#include "inc/hw_timer.h"
//#include "driverlib/timer.h"
//#include "driverlib/sysctl.h"

#include "Task_Sheduler.h"

//=================================================================================
//	STATE-MACHINE SEQUENCING AND SYNCRONIZATION FOR SLOW BACKGROUND TASKS
//=================================================================================

//--------------------------------- FRAMEWORK -------------------------------------
void ATaskState(void)
{
	// loop rate synchronizer for A-tasks
	if(TimerFlags.Timer0 == 1)
	{
		TimerFlags.Timer0 = 0;

		//-----------------------------------------------------------
		ATasks();		// jump to an A Task
		//-----------------------------------------------------------

	}

	State_Ptr = &BTaskState;		// Comment out to allow only A tasks
}

void BTaskState(void)
{
	// loop rate synchronizer for B-tasks
	if(TimerFlags.Timer1)
	{
		TimerFlags.Timer1 = 0;

		//-----------------------------------------------------------
		BTasks();		// jump to a B Task (B1,B2,B3,...)
		//-----------------------------------------------------------
	}

	State_Ptr = &CTaskState;		// Allow C state tasks
}

void CTaskState(void)
{
	// loop rate synchronizer for C-tasks
	if(TimerFlags.Timer2)
	{
		TimerFlags.Timer2 = 0;

		//-----------------------------------------------------------
		CTasks();		// jump to a C Task (C1,C2,C3,...)
		//-----------------------------------------------------------
	}

	State_Ptr = &ATaskState;	// Back to State A0
}

//extern TIMER_FLAGS TimerFlags;

